#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.20.0"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
